nomainwin
dim sizes(10)
sizes(1)=2
sizes(2)=2
sizes(3)=1
sizes(4)=1
sizes(5)=1
sizes(6)=1
sizes(7)=4
sizes(8)=4
sizes(9)=4
sizes(10)=4
dim bytes(24)
dim flags(16)
dim fls$(0,0)
dim spritesheet$(0)
dim tileset$(0)
global invalid

filedialog "Select npc.tbl file","*.tbl",file$

WindowWidth=488
WindowHeight=414
UpperLeftX=DisplayWidth/2-WindowWidth/2
UpperLeftY=DisplayHeight/2-WindowHeight/2
textbox #1.t, 10,10,110,25
button #1, "Load",[load],UL,10,45,50,25
button #1, "Save",[save],UL,70,45,50,25
groupbox #1, "Flags",10,90,460,100
checkbox #1.fc16,"Show damage",         fc1,fc0,20 ,105,108,18
checkbox #1.fc15,"Load if flag not set",fc1,fc0,20 ,125,108,18
checkbox #1.fc14,"Trigger on interact", fc1,fc0,20 ,145,108,18
checkbox #1.fc13,"Custom flag",         fc1,fc0,20 ,165,108,18
checkbox #1.fc12,"Load if flag set",    fc1,fc0,130,105,108,18
checkbox #1.fc11,"Drop hp/missiles",    fc1,fc0,130,125,108,18
checkbox #1.fc10,"Trigger on death",    fc1,fc0,130,145,108,18
checkbox #1.fc09,"Trigger on contact",  fc1,fc0,130,165,108,18
checkbox #1.fc08,"No rear/top damg",    fc1,fc0,240,105,108,18
checkbox #1.fc07,"Special solid",       fc1,fc0,240,125,108,18
checkbox #1.fc06,"Shootable",           fc1,fc0,240,145,108,18
checkbox #1.fc05,"Bounce top",          fc1,fc0,240,165,108,18
checkbox #1.fc04,"Pass through walls",  fc1,fc0,350,105,108,18
checkbox #1.fc03,"Invincible",          fc1,fc0,350,125,108,18
checkbox #1.fc02,"Pass through tile 44",fc1,fc0,350,145,108,18
checkbox #1.fc01,"Solid",               fc1,fc0,350,165,108,18
groupbox #1, "Death animation",150,10,320,80
radiobutton #1.dr0,"0",dr,[a],170,30,40,20
radiobutton #1.dr1,"1",dr,[a],170,55,40,20
radiobutton #1.dr2,"2",dr,[a],270,30,40,20
radiobutton #1.dr3,"3",dr,[a],270,55,40,20
groupbox #1, "Spritesheet",10,200,260,170
radiobutton #1.sr00,"Title.pbm",                  sr,[a],16, 215,96, 18
radiobutton #1.sr06,"Fade.pbm",                   sr,[a],16, 235,96, 18
radiobutton #1.sr08,"ItemImage.pbm",              sr,[a],16, 255,96, 18
radiobutton #1.sr16,"MyChar.pbm",                 sr,[a],16, 275,96, 18
radiobutton #1.sr17,"Bullet.pbm",                 sr,[a],16, 295,96, 18
radiobutton #1.sr19,"Caret.pbm",                  sr,[a],16, 315,96, 18
radiobutton #1.sr02,"Local tileset",              sr,[a],118,215,146,18
radiobutton #1.sr21,"Local spritesheet A",        sr,[a],118,235,146,18
radiobutton #1.sr22,"Local spritesheet B",        sr,[a],118,255,146,18
radiobutton #1.sr20,"Global spritesheet A (Sym)", sr,[a],118,295,146,18
radiobutton #1.sr23,"Global spritesheet B (Regu)",sr,[a],118,315,146,18
button #1,"Sprite options",[sprite],UL,16,340,248,25
textwidth=90
statictext #1, "Health:",      280, 200,    textwidth,26
textbox #1.t1,       290+textwidth, 200,180-textwidth,26
statictext #1, "Death sound:", 280, 236,    textwidth,26
textbox #1.t2,       290+textwidth, 236,180-textwidth,26
statictext #1, "Damage sound:",280, 272,    textwidth,26
textbox #1.t3,       290+textwidth, 272,180-textwidth,26
statictext #1, "Experience:",  280, 308,    textwidth,26
textbox #1.t4,       290+textwidth, 308,180-textwidth,26
statictext #1, "Damage:",      280, 344,    textwidth,26
textbox #1.t5,       290+textwidth, 344,180-textwidth,26
open "NPCTBL hacking tool" for window_nf as #1
#1, "trapclose [quit]"
call bytesOut
[a]
wait


[quit]
close #1
end


[load]
#1.t, "!contents? a"
if a<0 or a>360 or a>int(a) then notice "Invalid NPC number" : wait
open file$ for binary as #2
fpos=0
bpos=1
for i=1 to 10
    b=sizes(i)
    seek #2,fpos*361+a*b
    for j=1 to b
        bytes(bpos)=asc(input$(#2,1))
        bpos=bpos+1
    next j
    fpos=fpos+b
next i
close #2
if bytes(5)=2 then print a
call bytesOut
wait


[save]
#1.t, "!contents? a"
if a<0 or a>360 or a>int(a) then notice "Invalid NPC number" : wait
call bytesIn
if invalid then wait
open file$ for binary as #2
fpos=0
bpos=1
for i=1 to 10
    b=sizes(i)
    seek #2,fpos*361+a*b
    for j=1 to b
        #2, chr$(bytes(bpos))
        bpos=bpos+1
    next j
    fpos=fpos+b
next i
close #2
wait



sub bytesIn
    invalid=0
    bytes(1)=0
    bytes(2)=0
    a=1
    for i=1 to 8
        if flags(i) then bytes(1)=bytes(1)+a
        if flags(i+8) then bytes(2)=bytes(2)+a
        a=a*2
    next i
    call getbytes 3,1,2
    call getbytes 6,2,1
    call getbytes 7,3,1
    call getbytes 9,4,4
    call getbytes 13,5,4
end sub



sub bytesOut
    flags=bytes(1)+bytes(2)*256
    for i=1 to 16
        h$="#1.fc";twodig$(i)
        a=int(flags/2)
        flags(i)=2*a<flags
        if flags(i) then #h$, "set" else #h$, "reset"
        flags=a
    next i

    h$="#1.dr";bytes(8)
    #h$, "set"
    h$="#1.sr";twodig$(bytes(5))
    #h$, "set"

    #1.t1, bytes(4)*256+bytes(3)
    #1.t2, bytes(6)
    #1.t3, bytes(7)
    #1.t4, bytes(12)*65536*256+bytes(11)*65536+bytes(10)*256+bytes(9)
    #1.t5, bytes(16)*65536*256+bytes(15)*65536+bytes(14)*256+bytes(13)
end sub



function twodig$(a)
    if a<10 then twodig$="0";a else twodig$=str$(a)
end function



sub dr handle$
    bytes(8)=val(right$(handle$,1))
end sub



sub sr handle$
    bytes(5)=val(right$(handle$,2))
end sub



[sprite]
a=bytes(17)
prompt "Collide X1";a
bytes(17)=a
a=bytes(18)
prompt "Collide Y1";a
bytes(18)=a
a=bytes(19)
prompt "Collide X2";a
bytes(19)=a
a=bytes(20)
prompt "Collide Y2";a
bytes(20)=a
a=bytes(21)
prompt "Display X1";a
bytes(21)=a
a=bytes(22)
prompt "Display Y1";a
bytes(22)=a
a=bytes(23)
prompt "Display X2";a
bytes(23)=a
a=bytes(24)
prompt "Display Y2";a
bytes(24)=a
wait



sub getbytes index,tbox,bytes
    h$="#1.t";tbox
    #h$, "!contents? a"
    if a<0 or a>int(a) or a>=256^bytes then invalid=1 : notice "Invalid textbox value"
    if invalid=0 then
        for i=1 to bytes
            b=int(a/256)
            bytes(index)=a-256*b
            a=b
            index=index+1
        next i
    end if
end sub



sub fc1 handle$
    flags(val(right$(handle$,2)))=1
end sub



sub fc0 handle$
    flags(val(right$(handle$,2)))=0
end sub
